{******************************************}
{                                          }
{             FastReport VCL               }
{            PDF export filter             }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}
{      haBlock alignment improved by:      }
{              Nikolay Zverev              }
{            www.delphinotes.ru            }
{******************************************}

unit frxExportPDFDialog;

interface

{$I frx.inc}

uses
{$IFNDEF Linux}
  Windows,
{$ELSE}
  LCLType, LCLIntf, LCLProc,
{$ENDIF}
  SysUtils, Graphics, Controls, Classes, Forms, Dialogs, frxExportBaseDialog,
  StdCtrls, ExtCtrls, ComCtrls, Variants, frxPreview, Buttons, frxHelpers,
  frxExportPDF;

type
  TfrxPDFExportDialog = class(TfrxBaseExportDialog)
    InfoPage: TTabSheet;
    SecurityPage: TTabSheet;
    ViewerPage: TTabSheet;
    CompressedCB: TCheckBox;
    EmbeddedCB: TCheckBox;
    PrintOptCB: TCheckBox;
    OutlineCB: TCheckBox;
    BackgrCB: TCheckBox;
    SecGB: TGroupBox;
    OwnPassL: TLabel;
    UserPassL: TLabel;
    OwnPassE: TEdit;
    UserPassE: TEdit;
    PermGB: TGroupBox;
    PrintCB: TCheckBox;
    ModCB: TCheckBox;
    CopyCB: TCheckBox;
    AnnotCB: TCheckBox;
    DocInfoGB: TGroupBox;
    TitleL: TLabel;
    TitleE: TEdit;
    AuthorE: TEdit;
    AuthorL: TLabel;
    SubjectL: TLabel;
    SubjectE: TEdit;
    KeywordsL: TLabel;
    KeywordsE: TEdit;
    CreatorE: TEdit;
    CreatorL: TLabel;
    ProducerL: TLabel;
    ProducerE: TEdit;
    ViewerGB: TGroupBox;
    HideToolbarCB: TCheckBox;
    HideMenubarCB: TCheckBox;
    HideWindowUICB: TCheckBox;
    FitWindowCB: TCheckBox;
    CenterWindowCB: TCheckBox;
    PrintScalingCB: TCheckBox;
    QualityEdit: TEdit;
    Label2: TLabel;
    TransparentCB: TCheckBox;
    PDFStandardComboBox: TComboBox;
    PDFStandardLabel: TLabel;
    PDFVersionComboBox: TComboBox;
    PDFVersionLabel: TLabel;
    IFormsCB: TCheckBox;
    FontGLB: TLabel;
    FSubsetED: TEdit;
    SignaturePage: TTabSheet;
    AdditionalInformationGB: TGroupBox;
    LocationL: TLabel;
    ReasonL: TLabel;
    ContactL: TLabel;
    LocationE: TEdit;
    ReasonE: TEdit;
    ContactE: TEdit;
    CertificateGB: TGroupBox;
    CertificateFileB: TSpeedButton;
    CertificateFileE: TEdit;
    CertificateFileL: TLabel;
    CertificatePasswordL: TLabel;
    CertificatePasswordE: TEdit;
    CertificateOD: TOpenDialog;
    DescriptionListBox: TListBox;
    DescriptionLabel: TLabel;
    AutoFillButton: TButton;
    AddButton: TButton;
    DeleteButton: TButton;
    procedure PDFStandardComboBoxChange(Sender: TObject);
    procedure IFormsCBClick(Sender: TObject);
    procedure CertificateFileBClick(Sender: TObject);
    procedure OkBClick(Sender: TObject);
    procedure DescriptionListBoxClick(Sender: TObject);
    procedure DataEditChange(Sender: TObject);
    procedure AddButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure AutoFillButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  protected
    FPDFFilter: TfrxPDFExport;
    FSIL: TSignatureInfoList;

    procedure SetupComboBox(ComboBox: TComboBox; st: String);
    procedure DoStandard;
    function KindName(Index: Integer; Unknown: Boolean): string;
    procedure AddToDescriptionListBox(Index: Integer; Unknown: Boolean = False);
    procedure SetItemIndex(Index: Integer);
    procedure FillDescriptionListBox;

    procedure InitDialog; override;
    procedure InitControlsFromFilter(ExportFilter: TfrxBaseDialogExportFilter); override;
    procedure InitFilterFromDialog(ExportFilter: TfrxBaseDialogExportFilter); override;
  end;

implementation
end.
