unit frxTrueTypeCollection;

interface

{$I frx.inc}

uses
  Classes, SysUtils, Graphics,
{$IFNDEF Linux}
  Windows,
{$ELSE}
  LCLType, LCLIntf, LCLProc,
{$ENDIF}
  TTFHelpers, frxTrueTypeFont, frxFontHeaderClass, frxNameTableClass
{$IFDEF DELPHI16}
, System.UITypes
{$ENDIF};


type // Nested Types

  TFontCollection = TList;
  TTCollectionHeader = packed record
      TTCTag: Cardinal;
      Version: Cardinal;
      numFonts: Cardinal;
  end;

  TrueTypeCollection = class(TTF_Helpers)
    // Fields
    private fonts_collection: TFontCollection;

    private function get_FontCollection: TFontCollection;
    private function get_Item(FamilyName: string): TrueTypeFont;

    // Methods
    public constructor Create;
    destructor Destroy; override;
    public procedure Initialize(FD: PAnsiChar; FontDataSize: Longint);
    function LoadFont( font: Tfont) : TrueTypeFont;
//    public function PackFont( font: Tfont; UsedAlphabet: TList) : TByteArray;
    public function PackFont( ttf: TrueTypeFont; UsedAlphabet: TList) : TByteArray;

    // Properties
    public property FontCollection: TFontCollection read get_FontCollection;
    public property Item[FamilyName: string]: TrueTypeFont read get_Item;
  end;

{$WARNINGS OFF}
const
  // You may put national font names here
  // but they should be represented in Unicode in form of 32 bit numbers
    Elements =12;
    Substitutes  : array  [1..Elements] of WideString = (
{
      'ＭＳ ゴシック',        'MS Gothic',
      'ＭＳ Ｐゴシック',     'MS PGothic',
      'ＭＳ 明朝',              'MS Mincho',
      'ＭＳ Ｐ明朝',           'MS PMincho',
      'メイリオ',               'Meiryo',
}
      #$FF2D#$FF33#$0020#$30B4#$30B7#$30C3#$30AF,
        'MS Gothic',
      #$FF2D#$FF33#$0020#$FF30#$30B4#$30B7#$30C3#$30AF,
        'MS PGothic',
      #$FF2D#$FF33#$0020#$660E#$671D,
        'MS Mincho',
      #$FF2D#$FF33#$0020#$FF30#$660E#$671D,
        'MS PMincho',
      #$30E1#$30A4#$30EA#$30AA,
        'Meiryo',
      'Tahoma Bold',
        'Tahoma Negreta'
    );

implementation
end.
